﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.01
@EndOfDesignText@
'Custom View class 
#Event: OneClick
#Event: LongClick

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	
	' Zoom
	Private zm As Boolean = False
	#IF B4A
	Private mBase As Panel
	Public NatObject As ImageView
	Private StartX,StartY,LastX,LastY As Int
	Private Wd,Ht As Int
	Private PointerStartID=-1,PointerLastID=-1 As Int
	#ELSE IF B4I
	Private mBase As Panel
	Public NatObject As ImageView
	Private Multi As Panel
	Private Wd,Ht As Int
	Private NativeMe As NativeObject
	Private fingers As Map
	Type FingerData (StartX As Float, StartY As Float,LastX As Float, LastY As Float)
	Private Lastclick As Long = -1
	#ELSE IF B4J
	Private mBase As Pane
	Public NatObject As ImageView
	#END IF
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	NatObject.Initialize("MEvent")
	#IF B4I
	Multi.Initialize("MEvent")
	#END IF
End Sub

#IF B4A or B4I
Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
#ELSE IF B4J
Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
#End If
	mBase = Base

	#IF B4A
	mBase.AddView(NatObject,0,0,mBase.Width,mBase.Height)
	NatObject.Background=mBase.Background
	NatObject.Enabled=mBase.Enabled
	
	Dim obj As Reflector
	obj.Target = NatObject
	obj.SetOnTouchListener("NatObject_Touch")
	#ELSE IF B4I
	fingers.Initialize
	mBase.AddView(NatObject,0,0,mBase.Width,mBase.Height)
	mBase.AddView(Multi,0,0,mBase.Width,mBase.Height)
	Dim no As NativeObject = Multi
	no.SetField("multipleTouchEnabled", True)
	NativeMe=Me
	#ELSE IF B4J
	mBase.AddNode(NatObject,0,0,mBase.Width,mBase.Height)
	NatObject.Enabled=mBase.Enabled
	#End If
	NatObject.Tag=mBase.Tag
	NatObject.Visible=mBase.Visible
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	#IF B4J
	NatObject.SetSize(Width,Height)
	#ELSE IF B4i
'	NatObject.Width=Width
'	NatObject.Height=Height
	#End If
End Sub

Public Sub BringToFront
	#IF B4A or B4I
	mBase.BringToFront
	#ELSE IF B4j
	
	#End If
End Sub

#IF B4J
	Public Sub GetBase As Pane
		Return mBase
	End Sub
#ELSE
	Public Sub GetBase As Panel
		Return mBase
	End Sub
#End If

Public Sub setEnable(B As Boolean)
	#IF B4A or B4J
	mBase.Enabled=B
	#End If
End Sub

Public Sub getEnable As Boolean
	#IF B4A or B4J
	Return mBase.Enabled
	#ELSE
	Return True
	#END IF
End Sub

#IF B4A or B4i
Public Sub GetView(Index As Int) As View
	Return mBase.GetView(Index)
End Sub
#ELSE IF B4J
Public Sub GetView(Index As Int) As Node
	#IF B4A or B4I
	Return mBase.GetView(Index)
	#ELSE IF B4j
	Return mBase.GetNode(Index)
	#END IF
End Sub
#END IF

Public Sub setHeight(B As Float)
	#IF B4A or B4I
	mBase.Height=B
	#ELSE IF B4j
	mBase.PrefHeight=B
	#END IF
End Sub
Public Sub setLeft(B As Float)
	mBase.Left=B
End Sub

Public Sub getLeft As Float
	Return mBase.Left
End Sub

Public Sub getHeight As Float
	Return mBase.Width
End Sub

Public Sub RemoveViewFromParent
	#IF B4A
	mBase.RemoveView
	#ELSE IF B4i
	mBase.RemoveViewFromParent
	#ELSE IF B4J
	mBase.RemoveNodeFromParent
	#End If
End Sub

Public Sub RequestFocus
	mBase.RequestFocus
End Sub

Public Sub SendToBack
	#IF B4A or B4I
	mBase.SendToBack
	#ELSE IF B4j
	
	#END IF
End Sub

Public Sub setTag(B As Object)
	mBase.Tag=B
End Sub

Public Sub getTag As Object
	Return mBase.Tag
End Sub

Public Sub setTop(B As Float)
	mBase.Top=B
End Sub

Public Sub getTop As Float
	Return mBase.Width
End Sub

Public Sub setVisible(B As Boolean)
	mBase.Visible=B
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub setWidth(B As Float)
	#IF B4A or B4I
	mBase.Width=B
	#ELSE IF B4j
	mBase.PrefWidth=B
	#END IF
End Sub

Public Sub getWidth As Float
	Return mBase.Width
End Sub

Public Sub setZoom(B As Boolean)
	zm=B
	If B=False Then 
		NatObject.left=0
		NatObject.Top=0
		NatObject.Width=mBase.Width
		NatObject.Height=mBase.Height
	End If
End Sub

Public Sub getZoom As Boolean
	Return zm
End Sub

#iF B4A
Public Sub setBitmap(B As Bitmap)
	NatObject.SetBackgroundImage(B)
End Sub

Public Sub setGravity(I As Int)
	NatObject.Gravity=I
End Sub

Public Sub getGravity As Int
	Return NatObject.Gravity
End Sub
#ELSE IF B4i
Public Sub setBitmap(B As Bitmap)
	NatObject.Bitmap=B
End Sub
#ELSE IF B4J
Public Sub setBitmap(B As Image)
	NatObject.SetImage(B)
End Sub

Public Sub setPreserveRatio(B As Boolean)
	NatObject.PreserveRatio=B
End Sub

Public Sub getPreserveRatio As Boolean
	Return NatObject.PreserveRatio
End Sub

#End If

Public Sub setUrlBitmap(url As String)
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download(url)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		#iF B4A
			NatObject.SetBackgroundImage(j.GetBitmap)
		#ELSE IF B4i
			NatObject.Bitmap=j.GetBitmap
		#ELSE IF B4J
			NatObject.SetImage(j.GetBitmap)
		#End If
	End If
	j.Release
End Sub

'------------------------------  EVENT --------------------------------
#IF B4A

private Sub MEvent_Click
	If SubExists(mCallBack,mEventName & "_OneClick") Then CallSub(mCallBack,mEventName & "_OneClick")
End Sub

private Sub MEvent_LongClick
	If SubExists(mCallBack,mEventName & "_LongClick") Then CallSub(mCallBack,mEventName & "_LongClick")
End Sub

Private Sub NatObject_Touch(viewtag As Object, action As Int, X As Float, Y As Float, motionevent As Object) As Boolean
	If zm Then 
		Dim jo As JavaObject = motionevent
		Dim pc As Int = jo.RunMethod("getPointerCount", Null)
		If action = 0 Then ' Down
			If pc=1 Then
				PointerStartID=jo.RunMethod("getPointerId", Array As Object(0))
				StartX=jo.RunMethod("getX", Array As Object(0))
				StartY=jo.RunMethod("getY", Array As Object(0))
				'Log($"$Start ${StartX}--${StartY} * ${PointerStartID}"$)
				Wd=NatObject.Width
				Ht=NatObject.Height
			End If
		else if action=1 Then
			PointerStartID=-1
			PointerLastID=-1
		else if action=2 Then
			If pc=2 And PointerLastID=-1 Then 
				PointerLastID=jo.RunMethod("getPointerId", Array As Object(1))
				LastX=jo.RunMethod("getX", Array As Object(1))
				LastY=jo.RunMethod("getY", Array As Object(1))
				'Log($"$last ${LastX}--${LastY} * ${PointerLastID}"$)
			else If pc=2 Then 
				Private SX,SY,LX,LY As Int
				
				For p=0 To pc-1
					Dim PointerID As Int = jo.RunMethod("getPointerId", Array As Object(p))
					If PointerID=PointerStartID Then 
						SX=jo.RunMethod("getX", Array As Object(p))
						SY=jo.RunMethod("getY", Array As Object(p))
					else if PointerID=PointerLastID Then 
						LX=jo.RunMethod("getX", Array As Object(p))
						LY=jo.RunMethod("getY", Array As Object(p))
					End If
				Next
				
				Dim Ip1 As Float = Sqrt(Power(LastY-StartY,2)+Power(LastX-StartX,2))
				Dim Ip2 As Float = Sqrt(Power(LY-SY,2)+Power(LX-SX,2))
				'Log($"IP ${Ip1} * ${Ip2} Rapp:$1.1{Ip2/Ip1}"$)
				
				NatObject.Width=Wd*(Ip2/Ip1)
				NatObject.Height=Ht*(Ip2/Ip1)
				If NatObject.Width<mBase.Width Or NatObject.Height<mBase.Height Then 
					NatObject.SetLayout(0,0,mBase.Width,mBase.Height)
				Else 
					NatObject.Width=Min(mBase.Width*5,NatObject.Width)
					NatObject.Height=Min(mBase.Height*5,NatObject.Height)
					NatObject.Left=Min(0,StartX*(1-(Ip2/Ip1)))
					NatObject.top=Min(0,StartY*(1-(Ip2/Ip1)))
				End If
			End If
		End If
	End If
	
	Return False
End Sub

#ELSE IF B4J
	
private Sub MEvent_MouseClicked (EventData As MouseEvent)
	If EventData.ClickCount=1 Then
		If SubExists(mCallBack,mEventName & "_OneClick") Then CallSub(mCallBack,mEventName & "_OneClick")
	Else
		If SubExists(mCallBack,mEventName & "_LongClick") Then CallSub(mCallBack,mEventName & "_LongClick")
	End If
End Sub

private Sub MEvent_MouseDragged (EventData As MouseEvent)
	
End Sub

private Sub MEvent_Resize (Width As Double, Height As Double)
	
End Sub

private Sub MEvent_MouseMoved (EventData As MouseEvent)
	
End Sub
	
#ELSE IF B4i
'private Sub MEvent_Click
'	If SubExists(mCallBack,mEventName & "_OneClick",0) Then CallSub(mCallBack,mEventName & "_OneClick")
'End Sub
'
'private Sub MEvent_LongClick
'	If SubExists(mCallBack,mEventName & "_LongClick",0) Then CallSub(mCallBack,mEventName & "_LongClick")
'End Sub

' Multui Touch
Private Sub MEvent_MultiTouchBegan(touches As Object) As Boolean
	Dim list As List = touches
	Lastclick=DateTime.Now
	For Each t As NativeObject In list
		Dim point As List = NativeMe.RunMethod("UITouchToPoint::", Array(t, Sender))
		Dim fd As FingerData
		fd.StartX = point.Get(0)
		fd.StartY = point.Get(1)
		fd.LastX = point.Get(0)
		fd.LastY = point.Get(1)
		fingers.Put(t , fd)
		Wd=NatObject.Width
		Ht=NatObject.Height
	Next
	Return True
End Sub

Private Sub MEvent_MultiTouchMoved(touches As Object) As Boolean
	If zm Then 
		Dim list As List = touches
		Lastclick=-1
		If fingers.Size=2 Then
			Dim I As Int = 0
			Private StartX,StartY,LastX,LastY As Int
			Private SX,SY,LX,LY As Int

			For Each t As NativeObject In list
				Dim point As List = NativeMe.RunMethod("UITouchToPoint::", Array(t, Sender))
				Dim fd As FingerData = fingers.Get(t)
				fd.LastX = point.Get(0)
				fd.LastY = point.Get(1)
			Next

			For Each t As NativeObject In fingers.Keys
				Dim fd As FingerData = fingers.Get(t)
				If I=0 Then 
					StartX = fd.StartX
					StartY = fd.StartX
					SX = fd.LastX
					SY = fd.LastY
				else if I=1 Then 
					LastX = fd.StartX
					LastY = fd.Starty
					LX = fd.LastX
					LY = fd.LastY
				End If
				I=I+1
			Next
			
			'Log($"Inizio-Start ${StartX}-${StartY}  Last ${LastX}-${LastY}"$)
			'Log($"Fine- Start ${SX}-${SY}  Last ${LX}-${LY}"$)
			Dim Ip1 As Float = Sqrt(Power(LastY-StartY,2)+Power(LastX-StartX,2))
			Dim Ip2 As Float = Sqrt(Power(LY-SY,2)+Power(LX-SX,2))
			'Log($"IP ${Ip1} * ${Ip2} Rapp:$1.1{Ip2/Ip1}"$)
						
			NatObject.Width=Wd*(Ip2/Ip1)
			NatObject.Height=Ht*(Ip2/Ip1)
			If NatObject.Width<mBase.Width Or NatObject.Height<mBase.Height Then
				NatObject.SetLayoutAnimated(0,1,0,0,mBase.Width,mBase.Height)
			Else
				NatObject.Width=Min(mBase.Width*5,NatObject.Width)
				NatObject.Height=Min(mBase.Height*5,NatObject.Height)
				NatObject.Left=Min(0,StartX*(1-(Ip2/Ip1)))
				NatObject.top=Min(0,StartY*(1-(Ip2/Ip1)))
			End If
	'		Multi.Left=NatObject.Left
	'		Multi.Top=NatObject.Top
	'		Multi.Width=NatObject.Width
	'		Multi.Height=NatObject.Height
		End If
	End If
	
	Return True
End Sub

Private Sub MEvent_MultiTouchEnded(touches As Object) As Boolean
	Dim list As List = touches
	For Each t As NativeObject In list
		fingers.Remove(t)
		If fingers.Size=0 And Lastclick>-1 Then 
			If DateTime.Now-Lastclick>700 Then 
				'doubleclick
				If SubExists(mCallBack,mEventName & "_LongClick",0) Then CallSub(mCallBack,mEventName & "_LongClick")
			Else
				' click
				If SubExists(mCallBack,mEventName & "_OneClick",0) Then CallSub(mCallBack,mEventName & "_OneClick")
			End If
		End If
	Next
	Return True
End Sub

#End If

#if OBJC
- (NSArray*)UITouchToPoint:(UITouch*)t :(UIView*)view {
	CGPoint p = [t locationInView:view];
	return @[@(p.x), @(p.y)];
}
@end

@implementation B4IPanelView (override)

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    if ([B4IObjectWrapper raiseEvent:self :@"_multitouchbegan:" :@[[touches allObjects]]] == false)
        [super touchesMoved:touches withEvent:event];
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    if ([B4IObjectWrapper raiseEvent:self :@"_multitouchmoved:" :@[[touches allObjects]]] == false)
        [super touchesMoved:touches withEvent:event];
   
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	if ([B4IObjectWrapper raiseEvent:self :@"_multitouchended:" :@[[touches allObjects]]] == false)
        [super touchesMoved:touches withEvent:event];
}

#End If